{%- macro item_card(title, code, image, url, description, rate, category, dates_a_venir, is_featured=False, is_full_width=False, align="Left") -%}
{%- set align_items_class = resolve_class({
	'align-items-end': align == 'Right',
	'align-items-center': align == 'Center',
	'align-items-start': align == 'Left',
}) -%}
{%- set col_size = 3 if is_full_width else 4 -%}
{% if is_featured %}
<div class="col-sm-{{ col_size*2 }} item-card">
	<div class="card featured-item {{ align_items_class }}" style="height: auto; max-height: 360px;">
		{% if image %}
		<div class="row no-gutters">
			<div class="col-md-6">
				<img class="card-img" src="{{ image }}" alt="{{ title }}">
			</div>
			<div class="col-md-6">
				{{ item_card_body(title, code, description, url, rate, category, dates_a_venir, is_featured, align) }}
			</div>
		</div>
		{% else %}
			<div class="col-md-12">
				{{ item_card_body(title, code, description, url, rate, category, dates_a_venir, is_featured, align) }}
			</div>
		{% endif %}
	</div>
</div>
{% else %}
<div class="col-sm-{{ col_size }} item-card">
	<div class="card {{ align_items_class }}">
		{% if image %}
		<div class="card-img-container" style="height: auto; max-height: 210px;">
			<img class="card-img" src="{{ image }}" alt="{{ title }}" style="margin-top: 0rem;">
		</div>
		{% else %}
		<div class="card-img-top no-image">
			{{ frappe.utils.get_abbr(title) }}
		</div>
		{% endif %}
		{{ item_card_body(title, code, description, url, rate, category, dates_a_venir, is_featured, align) }}
	</div>
</div>
{% endif %}
{%- endmacro -%}


{%- macro item_card_body(title, code, description, url, rate, category, dates_a_venir, is_featured, align) -%}

{%- set stages = frappe.get_all('Stage', {'reference_article': code}, ['name', 'formule_tarifaire']) -%}

{%- if (stages | len) == 1 -%}
{%- set stage = stages[0] -%}
{%- else -%}
{%- set stage = 0 -%}
{%- endif -%}

{%- set align_class = resolve_class({
	'text-right': align == 'Right',
	'text-center': align == 'Center' and not is_featured,
	'text-left': align == 'Left' or is_featured,
}) -%}
<div class="card-body {{ align_class }}" style="padding: 1rem;">
	<div class="product-title" style="font-size: 1.15rem; height: 3.2rem; line-height: 1.15rem;">{{ title or '' }}</div>
	
	{%- if dates_a_venir and dates_a_venir | len > 4 -%}
	{%- set dates_trunc = dates_a_venir[0:4] -%}
	{%- else -%}
	{%- set dates_trunc = dates_a_venir -%}
	{%- endif -%}

	{% if dates_trunc %}
	<div class="product-category" style="font-size: 1.15rem; height: 3rem; overflow: ellipsis; line-height: 1.3rem; font-weight: 600; color: #dd6d2f;">
		{{ dates_trunc | join(' / ') }}
		{% if dates_a_venir | len > 4 %}
		{{ " / "}}<span style="font-style: italic; font-size: 1rem;">{{ "et plus encore ..." }}</span>
		{% endif %}
	</div>
	{% else %}
	<div class="product-category" style="font-size: 1.15rem; height: 3rem; overflow: ellipsis; line-height: 1.3rem; font-weight: 400;">
		{{ 'à venir / nous contacter' }}
	</div>
	{% endif %}
	
	{% if stage and 'prix libre' == stage.formule_tarifaire %}
	<div class="product-price">prix libre</div>
	{% elif stage and 'prix fixe ou prix libre' == stage.formule_tarifaire %}
	<div class="product-price">prix fixe ou prix libre</div>
	{% else %}
	<div class="product-price">{{ rate or '' }}</div>
	{% endif %}
</div>
<a href="/{{ url or '#' }}" class="stretched-link"></a>
{%- endmacro -%}